SystemOrganization addCategory: #'Rest-Tests'!
SystemOrganization addCategory: #'Rest-Tests-Server'!
SystemOrganization addCategory: #'Rest-Tests-Fixtures'!
SystemOrganization addCategory: #'Rest-Tests-Client'!

RestHttpHandler subclass: #RestPerformHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestPerformHttpHandler methodsFor: 'request processing' stamp: 'cs 2/19/2009 17:51'!
process: anHTTPRequest
	"Takes first element in path as classname and sends message from third path element to that class."

	|pc class selector result|
	pc := anHTTPRequest uri identifierPath.
	class := pc second asSymbol.
	selector := pc third asSymbol.
	
	Smalltalk at: class ifPresent: [:c | 
		(c class allSelectors includes: selector) ifTrue: [
			result := c perform: selector]].

	^ HTTPResponse ok
		entity: result asString;
		yourself! !

Object subclass: #TestEntity
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

TestEntity class
	instanceVariableNames: 'lastId'!

TestEntity class
	instanceVariableNames: 'lastId'!

TestEntity subclass: #SecondLevelTestObject
	instanceVariableNames: 'name testObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:34'!
newFrom: aDictionary
	^ self new name: (aDictionary at: 'name')! !

!SecondLevelTestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:55'!
primitivePropertyNames
	^ #(id name)! !

!SecondLevelTestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:35'!
delete
	self testObject removeSecondLevelTestObject: self.! !

!SecondLevelTestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 13:55'!
name
	^ name! !

!SecondLevelTestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 13:55'!
name: aString
	name := aString.! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:33'!
testObject
	^ testObject! !

!SecondLevelTestObject methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:33'!
testObject: anObject
	testObject := anObject! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:55'!
collectionPropertyNames
	^ #()! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:38'!
incrementId

	self pvtLastId: self pvtLastId + 1.
	^ self pvtLastId! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:37'!
initialize

	super initialize.
	self pvtLastId: 0.! !

!TestEntity class methodsFor: 'instance creation' stamp: 'SR 2/26/2009 15:59'!
prepare
	TestObject testObjects: OrderedCollection new.
	TestObject addTestObject: (TestObject new
		firstName: 'Test';
		lastName: 'Project';
		id: 1;
		addSecondLevelTestObject: (SecondLevelTestObject new name: 'Micha');
		yourself).
	TestObject addTestObject: (TestObject new
		firstName: 'Test2';
		lastName: 'Project2';
		id: 2).
	TestObject addTestObject: (TestObject new
		firstName: 'Test3';
		lastName: 'Project3';
		id: 3).
		! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:55'!
primitivePropertyNames
	^ #()! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:37'!
pvtLastId

	^ lastId ifNil: [lastId := 0]! !

!TestEntity class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:37'!
pvtLastId: anObject

	lastId := anObject! !

!TestEntity methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:13'!
id
	^ id! !

!TestEntity methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:13'!
id: anObject
	id := anObject! !

!TestEntity methodsFor: 'printing' stamp: 'SR 2/26/2009 15:45'!
jsonWriteOn: aStream
	| result |
	result := Dictionary newFrom: (self class primitivePropertyNames collect: [ :aSymbol |
			aSymbol -> (self perform: aSymbol)]).
	result addAll: (Dictionary newFrom: (self class collectionPropertyNames collect: [ :aSymbol |
			aSymbol -> ((self perform: aSymbol) collect: [:each | each restUri])])).
	result jsonWriteOn: aStream.! !

!TestEntity methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:13'!
restUri

	^ (RestMockResourceHttpHandler uriMapping at: self class) value: self! !

TestEntity subclass: #TestObject
	instanceVariableNames: 'firstName lastName secondLevelTestObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

TestObject class
	instanceVariableNames: 'testObjects'!

TestObject class
	instanceVariableNames: 'testObjects'!

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:31'!
addNewTestObject: aDictionary

	^ self addTestObject: (self newFrom: aDictionary)! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:31'!
addTestObject: aTestObject
	self testObjects add: aTestObject.
	aTestObject id: self incrementId.
	^ aTestObject! !

!TestObject class methodsFor: 'instance creation' stamp: 'SR 2/26/2009 14:00'!
all
	^ self testObjects! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:41'!
collectionPropertyNames
	^ #(secondLevelTestObjects)! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:33'!
newFrom: aDictionary
	^ self new
		firstName: (aDictionary at: 'firstName');
		lastName: (aDictionary at: 'lastName')! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:49'!
primitivePropertyNames
	^ #(id firstName lastName)! !

!TestObject class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:30'!
removeTestObject: aTestObject
	
	self testObjects remove: aTestObject.! !

!TestObject class methodsFor: 'instance creation' stamp: 'SR 2/26/2009 14:00'!
testObjects
	^ testObjects! !

!TestObject class methodsFor: 'instance creation' stamp: 'SR 2/26/2009 15:14'!
testObjects: aCollection
	testObjects := aCollection! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:27'!
addNewSecondLevelTestObject: aDictionary

	^ self addSecondLevelTestObject: (SecondLevelTestObject newFrom: aDictionary)! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:25'!
addSecondLevelTestObject: aSecondLevelTestObject 

	aSecondLevelTestObject
		testObject: self;
		id: aSecondLevelTestObject class incrementId.
	^ self secondLevelTestObjects add: aSecondLevelTestObject! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:29'!
delete
	^ self class removeTestObject: self! !

!TestObject methodsFor: 'accessing' stamp: 'topa 2/25/2009 11:31'!
firstName
	^ firstName! !

!TestObject methodsFor: 'accessing' stamp: 'topa 2/25/2009 11:31'!
firstName: anObject
	firstName := anObject! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:48'!
initialize
	super initialize.
	self secondLevelTestObjects: OrderedCollection new.! !

!TestObject methodsFor: 'accessing' stamp: 'topa 2/25/2009 11:31'!
lastName
	^ lastName! !

!TestObject methodsFor: 'accessing' stamp: 'topa 2/25/2009 11:31'!
lastName: anObject
	lastName := anObject! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 15:29'!
removeSecondLevelTestObject: aSecondLevelTestObject

	self secondLevelTestObjects remove: aSecondLevelTestObject ifAbsent: [^ aSecondLevelTestObject].
	aSecondLevelTestObject testObject: nil.
	^ aSecondLevelTestObject! !

!TestObject methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:25'!
secondLevelTestObjects
	^ secondLevelTestObjects! !

!TestObject methodsFor: 'accessing' stamp: 'SR 2/26/2009 15:25'!
secondLevelTestObjects: anObject
	secondLevelTestObjects := anObject! !

RestResourceHttpHandler subclass: #RestMockResourceHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Fixtures'!

!RestMockResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'mfp 2/24/2009 14:30'!
rootResources
	^ Dictionary newFrom:
		{'tests' -> TestObject }! !

!RestMockResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'SR 2/26/2009 16:01'!
uriMapping

	^ Dictionary newFrom:{
		TestObject -> [:test| '/tests/{1}' format: {test id}].
		SecondLevelTestObject -> [:test | '/tests{1}/secondLevel/{2}' format: {test testObject id. test id}]}! !

!Dictionary methodsFor: '*rest-tests' stamp: 'mt 2/16/2009 10:28'!
keysAndValuesCollect: aBlock 
	| newDict |
	newDict := Dictionary new.
	self keysAndValuesDo: [:key :value | newDict add: (aBlock value: key value: value)].
	^ newDict! !

TestCase subclass: #RestSocketTestCase
	instanceVariableNames: 'site'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestSocketTestCase class methodsFor: 'accessing' stamp: 'cs 2/19/2009 20:47'!
httpUrl
	^ 'http://www.google.com' asUrl! !

!RestSocketTestCase class methodsFor: 'accessing' stamp: 'topa 2/19/2009 19:10'!
url
	^ 'https://www.verisign.com/favicon.ico' asUrl! !

!RestSocketTestCase methodsFor: 'tests' stamp: 'mig 2/23/2009 16:45'!
testDefaultReturn

	self
		should: ((RestSocket    getDocumentFromUrl: self class httpUrl request: '') isKindOf: RestResponse);
		should: ((RestSocket    getDocumentFromUrl: self class url request: '') isKindOf: RestResponse);
		should: ((RestSocket    putDocumentFromUrl: self class url request: '' content: 'foo') isKindOf: RestResponse);
		should: ((RestSocket   postDocumentFromUrl: self class url request: '' content: 'bar') isKindOf: RestResponse);
		should: ((RestSocket deleteDocumentFromUrl: self class url request: '') isKindOf: RestResponse).! !

TestCase subclass: #RestTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

RestTest subclass: #RestHttpServiceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestHttpServiceTest methodsFor: 'running' stamp: 'topa 2/25/2009 13:28'!
setUp
	"avoid upcall"! !

!RestHttpServiceTest methodsFor: 'tests' stamp: 'cs 2/24/2009 18:27'!
testStartAndStop
	
	RestHttpService start.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isKindOf: RestHttpService);
		should: RestHttpService isRunning.
	
	RestHttpService stop.
	(Delay forMilliseconds: 100) wait.
	
	self
		should: (RestHttpService resource isNil);
		shouldnt: RestHttpService isRunning.! !

RestTest subclass: #RestObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Client'!

!RestObjectTest methodsFor: 'running' stamp: 'SR 2/26/2009 15:59'!
setUp
	"Install a handler for http service. Add a testObject to the database."

	super setUp.
	RestHttpService resource installHandler: RestMockResourceHttpHandler on: '/'.
	TestEntity prepare.
! !

!RestObjectTest methodsFor: 'running' stamp: 'mfp 2/24/2009 22:37'!
tearDown
	super tearDown.
	testObject := nil.! !

!RestObjectTest methodsFor: 'tests' stamp: 'SR 2/26/2009 15:06'!
testGetAllRestObjects
	| sut testObjects |
	
	testObjects := TestObject all.
	sut := RestObject newFromBase: 'http://127.0.0.1:8082/' with: 'tests'.
	
	self should: sut size = testObjects size.
	sut do: [ :eachSut |
		self should: (testObjects anySatisfy: [ :eachTestObject | 
			(eachSut id = eachTestObject id) and: [eachSut firstName = eachTestObject firstName] and: [eachSut lastName = eachTestObject lastName]])].! !

!RestObjectTest methodsFor: 'tests' stamp: 'SR 2/26/2009 16:06'!
testGetRestObject
	| sut testObject |
	
	testObject := TestObject all first.
	sut := RestObject newFromBase: 'http://127.0.0.1:8082/' with: ('tests/', testObject id asString).
	
	self 
		should: sut firstName = testObject firstName;
		should: sut lastName = testObject lastName;
		should: sut id = testObject id;
		should: sut secondLevelTestObjects size = testObject secondLevelTestObjects size";
		should: sut secondLevelTestObjects first id = testObject secondLevelTestObjects first id".! !

RestTest subclass: #RestPerformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Tests-Server'!

!RestPerformTest methodsFor: 'running' stamp: 'cs 2/24/2009 17:36'!
setUp
	super setUp.
	RestHttpService resource
		installHandler: RestPerformHttpHandler
		on: '/'! !

!RestPerformTest methodsFor: 'tests' stamp: 'mt 2/23/2009 12:18'!
testPort
	| response |
	response := self get: 'RestHttpService/port'.
	self should: response content = RestHttpService port asString.! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 2/25/2009 11:16'!
host
	'localhost'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 2/25/2009 11:16'!
ip
	'127.0.0.1'! !

!RestTest class methodsFor: 'testing' stamp: 'cs 2/15/2009 14:14'!
isAbstract
	^ self name = 'RestTest'! !

!RestTest class methodsFor: 'fixture-data' stamp: 'topa 2/25/2009 11:15'!
port
	^ 8082! !

!RestTest methodsFor: 'helping' stamp: 'mig 2/23/2009 16:45'!
delete: aPath
	"Send an HTTP request with DELETE to localhost at the port of the (singleton) rest HTTP service."
	
	^ RestSocket
		deleteDocumentFromUrl: (('http://localhost:{1}/{2}' format: {RestHttpService port. aPath}) asUrl)
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'topa 2/25/2009 13:16'!
get: aPath
	"Send an HTTP request with GET to localhost at the port of the (singleton) rest HTTP service."

	^ RestSocket
		getDocumentFromUrl: ('http://localhost:{1}/{2}' format: {RestHttpService port. aPath}) asUrl
		request: ''! !

!RestTest methodsFor: 'helping' stamp: 'mt 2/18/2009 15:09'!
jsonDataFrom: someFields
	"Create a string for all fields in the dictionary in JSON."
	
	| stream |
	stream := TextStream with: ''.
	(Dictionary newFrom: someFields) jsonWriteOn: stream.	
	^ stream contents! !

!RestTest methodsFor: 'helping' stamp: 'mig 2/23/2009 16:45'!
post: aPath content: aContent
	"Send an HTTP request with POST to localhost at the port of the (singleton) rest HTTP service. Append the given fields to the request body."

	^ RestSocket
		postDocumentFromUrl: (('http://localhost:{1}/{2}' format: {RestHttpService port. aPath}) asUrl)
		request: ''
		content: aContent! !

!RestTest methodsFor: 'helping' stamp: 'mig 2/23/2009 16:45'!
put: aPath content: aContent
	"Send an HTTP request with PUT to localhost at the port of the (singleton) rest HTTP service. Append the given fields to the request body."
	
	^ RestSocket
		putDocumentFromUrl: (('http://localhost:{1}/{2}' format: {RestHttpService port. aPath}) asUrl)
		request: ''
		content: aContent! !

!RestTest methodsFor: 'running' stamp: 'topa 2/25/2009 11:18'!
setUp
	RestHttpService startOn: self class port.
! !

!RestTest methodsFor: 'running' stamp: 'cs 2/15/2009 14:27'!
tearDown
	RestHttpService stop.! !
TestEntity initialize!
